/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.135 Revision 1.149
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.135 2010/03/03 23:57:13 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.149 2010/08/20 23:52:51 robbat2 Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
51 ;; 51 ;;
52 *) 52 *)
53 die "Unsupported EAPI: ${EAPI}" ;; 53 die "Unsupported EAPI: ${EAPI}" ;;
54esac 54esac
55 55
56
57# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
58# @DESCRIPTION:
59# Upstream MySQL considers the first two parts of the version number to be the
60# major version. Upgrades that change major version should always run
61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63
64# Cluster is a special case...
65if [[ "${PN}" == "mysql-cluster" ]]; then
66 case $PV in
67 6.1*|7.0*|7.1*) MYSQL_PV_MAJOR=5.1 ;;
68 esac
69fi
70
71
56# @ECLASS-VARIABLE: MYSQL_VERSION_ID 72# @ECLASS-VARIABLE: MYSQL_VERSION_ID
57# @DESCRIPTION: 73# @DESCRIPTION:
58# MYSQL_VERSION_ID will be: 74# MYSQL_VERSION_ID will be:
59# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 75# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
60# This is an important part, because many of the choices the MySQL ebuild will do 76# This is an important part, because many of the choices the MySQL ebuild will do
77# @DESCRIPTION: 93# @DESCRIPTION:
78# Specifiy if community features are available. Possible values are 1 (yes) 94# Specifiy if community features are available. Possible values are 1 (yes)
79# and 0 (no). 95# and 0 (no).
80# Community features are available in mysql-community 96# Community features are available in mysql-community
81# AND in the re-merged mysql-5.0.82 and newer 97# AND in the re-merged mysql-5.0.82 and newer
82if [ "${PN}" == "mysql-community" ]; then 98if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
83 MYSQL_COMMUNITY_FEATURES=1 99 MYSQL_COMMUNITY_FEATURES=1
84elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then 100elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
85 MYSQL_COMMUNITY_FEATURES=1 101 MYSQL_COMMUNITY_FEATURES=1
86elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then 102elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
87 MYSQL_COMMUNITY_FEATURES=1 103 MYSQL_COMMUNITY_FEATURES=1
88elif [ "${PV#5.4}" != "${PV}" ] ; then 104elif [ "${PV#5.4}" != "${PV}" ] ; then
89 MYSQL_COMMUNITY_FEATURES=1 105 MYSQL_COMMUNITY_FEATURES=1
90elif [ "${PV#5.5}" != "${PV}" ] ; then 106elif [ "${PV#5.5}" != "${PV}" ] ; then
91 MYSQL_COMMUNITY_FEATURES=1 107 MYSQL_COMMUNITY_FEATURES=1
92elif [ "${PV#6.0}" != "${PV}" ] ; then 108elif [ "${PV#6}" != "${PV}" ] ; then
109 MYSQL_COMMUNITY_FEATURES=1
110elif [ "${PV#7}" != "${PV}" ] ; then
93 MYSQL_COMMUNITY_FEATURES=1 111 MYSQL_COMMUNITY_FEATURES=1
94else 112else
95 MYSQL_COMMUNITY_FEATURES=0 113 MYSQL_COMMUNITY_FEATURES=0
96fi 114fi
97 115
112 >=sys-apps/sed-4 130 >=sys-apps/sed-4
113 >=sys-apps/texinfo-4.7-r1 131 >=sys-apps/texinfo-4.7-r1
114 >=sys-libs/readline-4.1 132 >=sys-libs/readline-4.1
115 >=sys-libs/zlib-1.2.3" 133 >=sys-libs/zlib-1.2.3"
116 134
135[[ "${PN}" == "mariadb" ]] \
136&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
137
117# Having different flavours at the same time is not a good idea 138# Having different flavours at the same time is not a good idea
118for i in "" "-community" ; do 139for i in "mysql" "mysql-community" "mysql-cluster" "mariadb" ; do
119 [[ "${i}" == ${PN#mysql} ]] || 140 [[ "${i}" == ${PN} ]] ||
120 DEPEND="${DEPEND} !dev-db/mysql${i}" 141 DEPEND="${DEPEND} !dev-db/${i}"
121done 142done
122 143
123RDEPEND="${DEPEND} 144RDEPEND="${DEPEND}
124 !minimal? ( dev-db/mysql-init-scripts ) 145 !minimal? ( dev-db/mysql-init-scripts )
125 selinux? ( sec-policy/selinux-mysql )" 146 selinux? ( sec-policy/selinux-mysql )"
134 155
135# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 156# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
136PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 157PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
137 158
138# For other stuff to bring us in 159# For other stuff to bring us in
139PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})" 160PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
140 161
141# Work out the default SERVER_URI correctly 162# Work out the default SERVER_URI correctly
142if [ -z "${SERVER_URI}" ]; then 163if [ -z "${SERVER_URI}" ]; then
143 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}" 164 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
165 if [ "${PN}" == "mariadb" ]; then
166 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
167 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
168 SERVER_URI="
169 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
170 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
171 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
172 "
144 # The community build is on the mirrors 173 # The community and cluster builds are on the mirrors
145 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 174 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
146 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz" 175 if [[ "${PN}" == "mysql-cluster" ]] ; then
176 URI_DIR="MySQL-Cluster"
177 URI_FILE="mysql-cluster-gpl"
178 else
179 URI_DIR="MySQL"
180 URI_FILE="mysql"
181 fi
182 URI_A="${URI_FILE}-${MY_PV}.tar.gz"
183 MIRROR_PV=$(get_version_component_range 1-2 ${PV})
184 # Recently upstream switched to an archive site, and not on mirrors
185 SERVER_URI="http://downloads.mysql.com/archives/${URI_FILE}-${MIRROR_PV}/${URI_A}
186 mirror://mysql/Downloads/${URI_DIR}-${PV%.*}/${URI_A}"
147 # The (old) enterprise source is on the primary site only 187 # The (old) enterprise source is on the primary site only
148 elif [ "${PN}" == "mysql" ]; then 188 elif [ "${PN}" == "mysql" ]; then
149 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz" 189 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
150 fi 190 fi
151fi 191fi
160 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 200 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
161 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 201 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
162 202
163DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 203DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
164HOMEPAGE="http://www.mysql.com/" 204HOMEPAGE="http://www.mysql.com/"
205if [[ "${PN}" == "mariadb" ]]; then
206 HOMEPAGE="http://askmonty.org/"
207 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
208fi
209if [[ "${PN}" == "mysql-community" ]]; then
210 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
211fi
165LICENSE="GPL-2" 212LICENSE="GPL-2"
166SLOT="0" 213SLOT="0"
167IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test" 214IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
168 215
169mysql_version_is_at_least "4.1" \ 216mysql_version_is_at_least "4.1" \
170&& IUSE="${IUSE} latin1" 217&& IUSE="${IUSE} latin1"
171 218
172mysql_version_is_at_least "4.1.3" \ 219if mysql_version_is_at_least "4.1.3" ; then
173&& IUSE="${IUSE} cluster extraengine" 220 IUSE="${IUSE} extraengine"
221 if [[ "${PN}" != "mysql-cluster" ]] ; then
222 IUSE="${IUSE} cluster"
223 fi
224fi
174 225
175mysql_version_is_at_least "5.0" \ 226mysql_version_is_at_least "5.0" \
176|| IUSE="${IUSE} raid" 227|| IUSE="${IUSE} raid"
177 228
178mysql_version_is_at_least "5.0.18" \ 229mysql_version_is_at_least "5.0.18" \
182|| IUSE="${IUSE} berkdb" 233|| IUSE="${IUSE} berkdb"
183 234
184[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \ 235[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
185&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 236&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
186 237
187# PBXT engine 238[[ "${PN}" == "mariadb" ]] \
239&& IUSE="${IUSE} libevent"
240
241# MariaDB has integrated PBXT
242# PBXT_VERSION means that we have a PBXT patch for this PV
243# PBXT was only introduced after 5.1.12
244pbxt_patch_available() {
245 [[ "${PN}" != "mariadb" ]] \
188mysql_version_is_at_least "5.1.12" \ 246 && mysql_version_is_at_least "5.1.12" \
189&& [[ -n "${PBXT_VERSION}" ]] \ 247 && [[ -n "${PBXT_VERSION}" ]]
248 return $?
249}
250
251pbxt_available() {
252 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
253 return $?
254}
255
256# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
257# MariaDB has integrated XtraDB
258# XTRADB_VERS means that we have a XTRADB patch for this PV
259# XTRADB was only introduced after 5.1.26
260xtradb_patch_available() {
261 [[ "${PN}" != "mariadb" ]] \
262 && mysql_version_is_at_least "5.1.26" \
263 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
264 return $?
265}
266
267
268pbxt_patch_available \
190&& PBXT_P="pbxt-${PBXT_VERSION}" \ 269&& PBXT_P="pbxt-${PBXT_VERSION}" \
191&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \ 270&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
192&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \ 271&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
272
273# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
274# vs. built outside the dir
275pbxt_available \
193&& IUSE="${IUSE} pbxt" 276&& IUSE="${IUSE} pbxt" \
194
195# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
196mysql_version_is_at_least "5.1.26" \ 277&& mysql_version_is_at_least "5.1.40" \
197&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \ 278&& PBXT_NEWSTYLE=1
279
280xtradb_patch_available \
198&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \ 281&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
199&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \ 282&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
200&& XTRADB_SRC_URI1="http://www.percona.com/percona-builds/xtradb/${XTRADB_SRC_URI_COMMON}" \ 283&& XTRADB_SRC_B1="http://www.percona.com/" \
284&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
285&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
201&& XTRADB_SRC_URI2="http://www.percona.com/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \ 286&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
287&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
202&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} )" \ 288&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
203&& IUSE="${IUSE} xtradb" 289&& IUSE="${IUSE} xtradb"
204 290
205# 291#
206# HELPER FUNCTIONS: 292# HELPER FUNCTIONS:
207# 293#
304 MY_DATADIR="${new_MY_DATADIR}" 390 MY_DATADIR="${new_MY_DATADIR}"
305 fi 391 fi
306 fi 392 fi
307 fi 393 fi
308 394
395 if [ "${MY_SOURCEDIR:-unset}" == "unset" ]; then
309 MY_SOURCEDIR=${SERVER_URI##*/} 396 MY_SOURCEDIR=${SERVER_URI##*/}
310 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 397 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
398 fi
311 399
312 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 400 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
313 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 401 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
314 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR 402 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
315} 403}
362 if use debug ; then 450 if use debug ; then
363 myconf="${myconf} --with-debug=full" 451 myconf="${myconf} --with-debug=full"
364 else 452 else
365 myconf="${myconf} --without-debug" 453 myconf="${myconf} --without-debug"
366 mysql_version_is_at_least "4.1.3" \ 454 mysql_version_is_at_least "4.1.3" \
367 && use cluster \ 455 && ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) \
368 && myconf="${myconf} --without-ndb-debug" 456 && myconf="${myconf} --without-ndb-debug"
369 fi 457 fi
370 458
371 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then 459 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
372 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}" 460 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
396 myconf="${myconf} $(use_with perl bench)" 484 myconf="${myconf} $(use_with perl bench)"
397 myconf="${myconf} --enable-assembler" 485 myconf="${myconf} --enable-assembler"
398 myconf="${myconf} --with-extra-tools" 486 myconf="${myconf} --with-extra-tools"
399 myconf="${myconf} --with-innodb" 487 myconf="${myconf} --with-innodb"
400 myconf="${myconf} --without-readline" 488 myconf="${myconf} --without-readline"
489 myconf="${myconf} $(use_with ssl openssl)"
401 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 490 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
402 491
403 # --with-vio is not needed anymore, it's on by default and 492 # --with-vio is not needed anymore, it's on by default and
404 # has been removed from configure 493 # has been removed from configure
494 # Apply to 4.x and 5.0.[0-3]
405 if use ssl ; then 495 if use ssl ; then
406 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 496 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
407 fi
408
409 if mysql_version_is_at_least "5.1.11" ; then
410 myconf="${myconf} $(use_with ssl /usr)"
411 else
412 myconf="${myconf} $(use_with ssl openssl)"
413 fi 497 fi
414 498
415 if mysql_version_is_at_least "5.0.60" ; then 499 if mysql_version_is_at_least "5.0.60" ; then
416 if use berkdb ; then 500 if use berkdb ; then
417 elog "Berkeley DB support was disabled due to build failures" 501 elog "Berkeley DB support was disabled due to build failures"
433 myconf="${myconf} --without-berkeley-db" 517 myconf="${myconf} --without-berkeley-db"
434 fi 518 fi
435 519
436 if mysql_version_is_at_least "4.1.3" ; then 520 if mysql_version_is_at_least "4.1.3" ; then
437 myconf="${myconf} --with-geometry" 521 myconf="${myconf} --with-geometry"
522 if [[ "${PN}" != "mysql-cluster" ]] ; then
438 myconf="${myconf} $(use_with cluster ndbcluster)" 523 myconf="${myconf} $(use_with cluster ndbcluster)"
524 fi
439 fi 525 fi
440 526
441 if mysql_version_is_at_least "4.1.3" && use extraengine ; then 527 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
442 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 528 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
443 myconf="${myconf} --with-archive-storage-engine" 529 myconf="${myconf} --with-archive-storage-engine"
474 560
475configure_51() { 561configure_51() {
476 # TODO: !!!! readd --without-readline 562 # TODO: !!!! readd --without-readline
477 # the failure depend upon config/ac-macros/readline.m4 checking into 563 # the failure depend upon config/ac-macros/readline.m4 checking into
478 # readline.h instead of history.h 564 # readline.h instead of history.h
479 myconf="${myconf} $(use_with ssl)" 565 myconf="${myconf} $(use_with ssl ssl /usr)"
480 myconf="${myconf} --enable-assembler" 566 myconf="${myconf} --enable-assembler"
481 myconf="${myconf} --with-geometry" 567 myconf="${myconf} --with-geometry"
482 myconf="${myconf} --with-readline" 568 myconf="${myconf} --with-readline"
483 myconf="${myconf} --with-zlib-dir=/usr/" 569 myconf="${myconf} --with-zlib-dir=/usr/"
484 myconf="${myconf} --without-pstack" 570 myconf="${myconf} --without-pstack"
571 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
572
485 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 573 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
574 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
575 myconf="${myconf} $(use_enable community community-features)"
576 if use community; then
577 myconf="${myconf} $(use_enable profiling)"
578 else
579 myconf="${myconf} --disable-profiling"
580 fi
581 fi
582
583 # Scan for all available plugins
584 local plugins_avail="$(
585 LANG=C \
586 find "${S}" \
587 \( \
588 -name 'plug.in' \
589 -o -iname 'configure.in' \
590 -o -iname 'configure.ac' \
591 \) \
592 -print0 \
593 | xargs -0 sed -r -n \
594 -e '/^MYSQL_STORAGE_ENGINE/{
595 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
596 s~^([^ ]+).*~\1~gp;
597 }' \
598 | tr -s '\n' ' '
599 )"
486 600
487 # 5.1 introduces a new way to manage storage engines (plugins) 601 # 5.1 introduces a new way to manage storage engines (plugins)
488 # like configuration=none 602 # like configuration=none
603 # This base set are required, and will always be statically built.
489 local plugins="csv,myisam,myisammrg,heap" 604 local plugins_sta="csv myisam myisammrg heap"
605 local plugins_dyn=""
606 local plugins_dis="example ibmdb2i"
607
608 # These aren't actually required by the base set, but are really useful:
609 plugins_sta="${plugins_sta} archive blackhole"
610
611 # default in 5.5.4
612 if mysql_version_is_at_least "5.5.4" ; then
613 plugins_sta="${plugins_sta} partition"
614 fi
615 # Now the extras
490 if use extraengine ; then 616 if use extraengine ; then
491 # like configuration=max-no-ndb, archive and example removed in 5.1.11 617 # like configuration=max-no-ndb, archive and example removed in 5.1.11
492 # not added yet: ibmdb2i 618 # not added yet: ibmdb2i
493 # Not supporting as examples: example,daemon_example,ftexample 619 # Not supporting as examples: example,daemon_example,ftexample
494 plugins="${plugins},archive,blackhole,federated,partition" 620 plugins_sta="${plugins_sta} partition"
621 plugins_dyn="${plugins_sta} federated"
495 622
623 if [[ "${PN}" != "mariadb" ]] ; then
496 elog "Before using the Federated storage engine, please be sure to read" 624 elog "Before using the Federated storage engine, please be sure to read"
497 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 625 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
626 else
627 elog "MariaDB includes the FederatedX engine. Be sure to read"
628 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
629 fi
630 else
631 plugins_dis="${plugins_dis} partition federated"
498 fi 632 fi
499 633
500 # Upstream specifically requests that InnoDB always be built: 634 # Upstream specifically requests that InnoDB always be built:
501 # - innobase, innodb_plugin 635 # - innobase, innodb_plugin
502 # Build falcon if available for 6.x series. 636 # Build falcon if available for 6.x series.
503 for i in innobase innodb_plugin falcon ; do 637 for i in innobase falcon ; do
504 [ -e "${S}"/storage/${i} ] && plugins="${plugins},${i}" 638 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
505 done 639 done
640 for i in innodb_plugin ; do
641 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
642 done
506 643
507 # like configuration=max-no-ndb 644 # like configuration=max-no-ndb
508 if use cluster ; then 645 if ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) ; then
509 plugins="${plugins},ndbcluster" 646 plugins_sta="${plugins_sta} ndbcluster partition"
647 plugins_dis="${plugins_dis//partition}"
510 myconf="${myconf} --with-ndb-binlog" 648 myconf="${myconf} --with-ndb-binlog"
649 else
650 plugins_dis="${plugins_dis} ndbcluster"
511 fi 651 fi
512 652
653 if [[ "${PN}" == "mariadb" ]] ; then
654 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
655 # caught above.
656 plugins_sta="${plugins_sta} maria innobase"
657 myconf="${myconf} $(use_with libevent)"
658 # This is not optional, without it several upstream testcases fail.
659 # Also strongly recommended by upstream.
660 myconf="${myconf} --with-maria-tmp-tables"
661 fi
662
663 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
664 use pbxt \
665 && plugins_dyn="${plugins_dyn} pbxt" \
666 || plugins_dis="${plugins_dis} pbxt"
667 fi
668
669 use static && \
670 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
671 plugins_dyn=""
672
673 einfo "Available plugins: ${plugins_avail}"
674 einfo "Dynamic plugins: ${plugins_dyn}"
675 einfo "Static plugins: ${plugins_sta}"
676 einfo "Disabled plugins: ${plugins_dis}"
677
678 # These are the static plugins
513 myconf="${myconf} --with-plugins=${plugins}" 679 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
514} 680 # And the disabled ones
515 681 for i in ${plugins_dis} ; do
516xtradb_applicable() { 682 myconf="${myconf} --without-plugin-${i}"
517 mysql_version_is_at_least "5.1.26" \ 683 done
518 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
519 && use xtradb
520 return $?
521}
522
523pbxt_applicable() {
524 mysql_version_is_at_least "5.1.12" \
525 && [[ -n "${PBXT_VERSION}" ]] \
526 && use pbxt
527 return $?
528} 684}
529 685
530pbxt_src_configure() { 686pbxt_src_configure() {
531 mysql_init_vars 687 mysql_init_vars
532 688
534 690
535 einfo "Reconfiguring dir '${PWD}'" 691 einfo "Reconfiguring dir '${PWD}'"
536 AT_GNUCONF_UPDATE="yes" eautoreconf 692 AT_GNUCONF_UPDATE="yes" eautoreconf
537 693
538 local myconf="" 694 local myconf=""
539 myconf="${myconf} --with-mysql=${S} --libdir=${MY_LIBDIR}" 695 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
540 use debug && myconf="${myconf} --with-debug=full" 696 use debug && myconf="${myconf} --with-debug=full"
541 # TODO: is it safe/needed to use econf here ?
542 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 697 econf ${myconf} || die "Problem configuring PBXT storage engine"
543} 698}
544 699
545pbxt_src_compile() { 700pbxt_src_compile() {
701
546 # Be backwards compatible for now 702 # Be backwards compatible for now
547 if [[ $EAPI != 2 ]]; then 703 if [[ $EAPI != 2 ]]; then
548 pbxt_src_configure 704 pbxt_src_configure
549 fi 705 fi
550 # TODO: is it safe/needed to use emake here ? 706 # TODO: is it safe/needed to use emake here ?
579 fi 735 fi
580 fi 736 fi
581 737
582 # Check for USE flag problems in pkg_setup 738 # Check for USE flag problems in pkg_setup
583 if use static && use ssl ; then 739 if use static && use ssl ; then
584 eerror "MySQL does not support being built statically with SSL support enabled!"
585 die "MySQL does not support being built statically with SSL support enabled!" 740 M="MySQL does not support being built statically with SSL support enabled!"
741 eerror "${M}"
742 die "${M}"
586 fi 743 fi
587 744
588 if ! mysql_version_is_at_least "5.0" \ 745 if ! mysql_version_is_at_least "5.0" \
589 && use raid \ 746 && use raid \
590 && use static ; then 747 && use static ; then
592 eerror "with RAID support enabled." 749 eerror "with RAID support enabled."
593 die "USE flags 'raid' and 'static' conflict!" 750 die "USE flags 'raid' and 'static' conflict!"
594 fi 751 fi
595 752
596 if mysql_version_is_at_least "4.1.3" \ 753 if mysql_version_is_at_least "4.1.3" \
597 && ( use cluster || use extraengine ) \ 754 && ( use cluster || use extraengine || use embedded ) \
598 && use minimal ; then 755 && use minimal ; then
599 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
600 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 756 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
757 eerror "${M}"
758 die "${M}"
601 fi 759 fi
602 760
603 # Bug #290570 fun. Upstream made us need a fairly new GCC4.
604 if mysql_version_is_at_least "5.0.83" ; then 761 if mysql_version_is_at_least "5.1" \
762 && xtradb_patch_available \
763 && use xtradb \
764 && use embedded ; then
765 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
766 eerror "${M}"
767 die "${M}"
768 fi
769
770 # Bug #290570, 284946, 307251
771 # Upstream changes made us need a fairly new GCC4.
772 # But only for 5.0.8[3-6]!
773 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
605 GCC_VER=$(gcc-version) 774 GCC_VER=$(gcc-version)
606 case ${GCC_VER} in 775 case ${GCC_VER} in
607 2*|3*|4.0|4.1|4.2) die "Active GCC too old! Must have at least GCC4.3" ;; 776 2*|3*|4.0|4.1|4.2)
777 eerror "Some releases of MySQL required a very new GCC, and then"
778 eerror "later release relaxed that requirement again. Either pick a"
779 eerror "MySQL >=5.0.87, or use a newer GCC."
780 die "Active GCC too old!" ;;
608 esac 781 esac
609 fi 782 fi
610 783
611 # This should come after all of the die statements 784 # This should come after all of the die statements
612 enewgroup mysql 60 || die "problem adding 'mysql' group" 785 enewgroup mysql 60 || die "problem adding 'mysql' group"
665 838
666 # last -fPIC fixup, per bug #305873 839 # last -fPIC fixup, per bug #305873
667 i="${S}"/storage/innodb_plugin/plug.in 840 i="${S}"/storage/innodb_plugin/plug.in
668 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}" 841 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
669 842
670 # Additional checks, remove bundled zlib 843 # Additional checks, remove bundled zlib (Cluster needs this, for static
844 # memory management in zlib, leave available for Cluster)
845 if [[ "${PN}" != "mysql-cluster" ]] ; then
671 rm -f "${S}/zlib/"*.[ch] 846 rm -f "${S}/zlib/"*.[ch]
672 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 847 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
848 fi
673 rm -f "scripts/mysqlbug" 849 rm -f "scripts/mysqlbug"
674 850
675 # Make charsets install in the right place 851 # Make charsets install in the right place
676 find . -name 'Makefile.am' \ 852 find . -name 'Makefile.am' \
677 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 853 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
687 rm -f "scripts/mysqlbug" 863 rm -f "scripts/mysqlbug"
688 fi 864 fi
689 865
690 local rebuilddirlist d 866 local rebuilddirlist d
691 867
692 if xtradb_applicable ; then 868 if xtradb_patch_available && use xtradb ; then
693 einfo "Replacing InnoDB with Percona XtraDB" 869 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
694 pushd "${S}"/storage 870 pushd "${S}"/storage >/dev/null
695 i="innobase" 871 i="innobase"
696 o="${WORKDIR}/storage-${i}.mysql-upstream" 872 o="${WORKDIR}/storage-${i}.mysql-upstream"
697 # Have we been here already? 873 # Have we been here already?
698 [ -d "${o}" ] && rm -f "${i}" 874 [ -d "${o}" ] && rm -f "${i}"
699 # Or maybe we haven't 875 # Or maybe we haven't
700 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 876 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
701 cp -ra "${WORKDIR}/${XTRADB_P}" "${i}" 877 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
702 popd 878 popd >/dev/null
879 fi
880
881 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
882 einfo "Adding storage engine: PBXT"
883 pushd "${S}"/storage >/dev/null
884 i='pbxt'
885 [ -d "${i}" ] && rm -rf "${i}"
886 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
887 popd >/dev/null
703 fi 888 fi
704 889
705 if mysql_version_is_at_least "5.1.12" ; then 890 if mysql_version_is_at_least "5.1.12" ; then
706 rebuilddirlist="." 891 rebuilddirlist="."
707 # This does not seem to be needed presently. robbat2 2010/02/23 892 # This does not seem to be needed presently. robbat2 2010/02/23
801 # TODO: Move this before autoreconf !!! 986 # TODO: Move this before autoreconf !!!
802 find . -type f -name Makefile -print0 \ 987 find . -type f -name Makefile -print0 \
803 | xargs -0 -n100 sed -i \ 988 | xargs -0 -n100 sed -i \
804 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 989 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
805 990
806 if [[ $EAPI == 2 ]]; then 991 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
807 pbxt_applicable && pbxt_src_configure 992 pbxt_patch_available && use pbxt && pbxt_src_configure
808 fi 993 fi
809} 994}
810 995
811# @FUNCTION: mysql_src_compile 996# @FUNCTION: mysql_src_compile
812# @DESCRIPTION: 997# @DESCRIPTION:
813# Compile the mysql code. 998# Compile the mysql code.
814mysql_src_compile() { 999mysql_src_compile() {
815 # Be backwards compatible for now 1000 # Be backwards compatible for now
816 case ${EAPI:-0} in 1001 case ${EAPI:-0} in
817 2) : ;; 1002 2) : ;;
818 0 | 1) mysql_src_configure ;; 1003 0 | 1) mysql_src_configure ;;
819 esac 1004 esac
820 1005
821 emake || die "emake failed" 1006 emake || die "emake failed"
822 1007
823 pbxt_applicable && pbxt_src_compile 1008 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1009 pbxt_patch_available && use pbxt && pbxt_src_compile
1010 fi
824} 1011}
825 1012
826# @FUNCTION: mysql_src_install 1013# @FUNCTION: mysql_src_install
827# @DESCRIPTION: 1014# @DESCRIPTION:
828# Install mysql. 1015# Install mysql.
834 DESTDIR="${D}" \ 1021 DESTDIR="${D}" \
835 benchdir_root="${MY_SHAREDSTATEDIR}" \ 1022 benchdir_root="${MY_SHAREDSTATEDIR}" \
836 testroot="${MY_SHAREDSTATEDIR}" \ 1023 testroot="${MY_SHAREDSTATEDIR}" \
837 || die "emake install failed" 1024 || die "emake install failed"
838 1025
839 pbxt_applicable && pbxt_src_install 1026 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1027 pbxt_patch_available && use pbxt && pbxt_src_install
1028 fi
840 1029
841 # Convenience links 1030 # Convenience links
842 einfo "Making Convenience links for mysqlcheck multi-call binary" 1031 einfo "Making Convenience links for mysqlcheck multi-call binary"
843 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 1032 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
844 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 1033 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
868 if use !test ; then 1057 if use !test ; then
869 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test 1058 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
870 fi 1059 fi
871 1060
872 # Configuration stuff 1061 # Configuration stuff
1062 if mysql_version_is_at_least "5.1" ; then
1063 mysql_mycnf_version="5.1"
873 if mysql_version_is_at_least "4.1" ; then 1064 elif mysql_version_is_at_least "4.1" ; then
874 mysql_mycnf_version="4.1" 1065 mysql_mycnf_version="4.1"
875 else 1066 else
876 mysql_mycnf_version="4.0" 1067 mysql_mycnf_version="4.0"
877 fi 1068 fi
878 einfo "Building default my.cnf" 1069 einfo "Building default my.cnf"
880 doins scripts/mysqlaccess.conf 1071 doins scripts/mysqlaccess.conf
881 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1072 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
882 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1073 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
883 > "${TMPDIR}/my.cnf.ok" 1074 > "${TMPDIR}/my.cnf.ok"
884 if mysql_version_is_at_least "4.1" && use latin1 ; then 1075 if mysql_version_is_at_least "4.1" && use latin1 ; then
885 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 1076 sed -i \
1077 -e "/character-set/s|utf8|latin1|g" \
1078 "${TMPDIR}/my.cnf.ok"
886 fi 1079 fi
887 newins "${TMPDIR}/my.cnf.ok" my.cnf 1080 newins "${TMPDIR}/my.cnf.ok" my.cnf
888 1081
889 # Minimal builds don't have the MySQL server 1082 # Minimal builds don't have the MySQL server
890 if ! use minimal ; then 1083 if ! use minimal ; then
966 for script in \ 1159 for script in \
967 support-files/my-*.cnf \ 1160 support-files/my-*.cnf \
968 support-files/magic \ 1161 support-files/magic \
969 support-files/ndb-config-2-node.ini 1162 support-files/ndb-config-2-node.ini
970 do 1163 do
1164 [[ -f "${script}" ]] \
971 dodoc "${script}" 1165 && dodoc "${script}"
972 done 1166 done
973 1167
974 docinto "scripts" 1168 docinto "scripts"
975 for script in scripts/mysql* ; do 1169 for script in scripts/mysql* ; do
1170 [[ -f "${script}" ]] \
976 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1171 && [[ "${script%.sh}" == "${script}" ]] \
1172 && dodoc "${script}"
977 done 1173 done
978 1174
979 einfo 1175 einfo
980 elog "You might want to run:" 1176 elog "You might want to run:"
981 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1177 elog "\"emerge --config =${CATEGORY}/${PF}\""
982 elog "if this is a new install." 1178 elog "if this is a new install."
983 einfo 1179 einfo
984 fi 1180 fi
985 1181
986 if pbxt_applicable ; then 1182 if pbxt_available && use pbxt ; then
987 # TODO: explain it better 1183 # TODO: explain it better
988 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 1184 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
989 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 1185 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
990 elog "if, after that, you cannot start the MySQL server," 1186 elog "if, after that, you cannot start the MySQL server,"
991 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 1187 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
1042 fi 1238 fi
1043 fi 1239 fi
1044 1240
1045 local pwd1="a" 1241 local pwd1="a"
1046 local pwd2="b" 1242 local pwd2="b"
1243 local MYSQL_ROOT_PASSWORD=''
1047 local maxtry=5 1244 local maxtry=15
1245
1246 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1247 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1248 fi
1048 1249
1049 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then 1250 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
1050 ewarn "You have already a MySQL database in place." 1251 ewarn "You have already a MySQL database in place."
1051 ewarn "(${ROOT}/${MY_DATADIR}/*)" 1252 ewarn "(${ROOT}/${MY_DATADIR}/*)"
1052 ewarn "Please rename or delete it if you wish to replace it." 1253 ewarn "Please rename or delete it if you wish to replace it."
1055 1256
1056 # Bug #213475 - MySQL _will_ object strenously if your machine is named 1257 # Bug #213475 - MySQL _will_ object strenously if your machine is named
1057 # localhost. Also causes weird failures. 1258 # localhost. Also causes weird failures.
1058 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1259 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
1059 1260
1060 einfo "Creating the mysql database and setting proper" 1261 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1061 einfo "permissions on it ..."
1062 1262
1063 einfo "Insert a password for the mysql 'root' user" 1263 einfo "Please provide a password for the mysql 'root' user now,"
1264 einfo "or in the MYSQL_ROOT_PASSWORD env var."
1064 ewarn "Avoid [\"'\\_%] characters in the password" 1265 ewarn "Avoid [\"'\\_%] characters in the password"
1065 read -rsp " >" pwd1 ; echo 1266 read -rsp " >" pwd1 ; echo
1066 1267
1067 einfo "Retype the password" 1268 einfo "Retype the password"
1068 read -rsp " >" pwd2 ; echo 1269 read -rsp " >" pwd2 ; echo
1069 1270
1070 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1271 if [[ "x$pwd1" != "x$pwd2" ]] ; then
1071 die "Passwords are not the same" 1272 die "Passwords are not the same"
1273 fi
1274 MYSQL_ROOT_PASSWORD="${pwd1}"
1275 unset pwd1 pwd2
1072 fi 1276 fi
1073 1277
1074 local options="" 1278 local options=""
1075 local sqltmp="$(emktemp)" 1279 local sqltmp="$(emktemp)"
1076 1280
1090 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 1294 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
1091 || die "MySQL databases not installed" 1295 || die "MySQL databases not installed"
1092 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null 1296 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
1093 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null 1297 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
1094 1298
1299 # Figure out which options we need to disable to do the setup
1300 helpfile="${TMPDIR}/mysqld-help"
1301 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1302 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1303 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1304 ndbcluster \
1305 ; do
1306 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1307 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1308 done
1309 # But some options changed names
1310 egrep -sq external-locking "${helpfile}" && \
1311 options="${options/skip-locking/skip-external-locking}"
1312
1095 if mysql_version_is_at_least "4.1.3" ; then 1313 if mysql_version_is_at_least "4.1.3" ; then
1096 options="--skip-ndbcluster"
1097
1098 # Filling timezones, see 1314 # Filling timezones, see
1099 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1315 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
1100 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 1316 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
1101 1317
1102 if [[ -r "${help_tables}" ]] ; then 1318 if [[ -r "${help_tables}" ]] ; then
1103 cat "${help_tables}" >> "${sqltmp}" 1319 cat "${help_tables}" >> "${sqltmp}"
1104 fi 1320 fi
1105 fi 1321 fi
1322
1323 einfo "Creating the mysql database and setting proper"
1324 einfo "permissions on it ..."
1106 1325
1107 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1326 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
1108 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1327 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
1109 local mysqld="${ROOT}/usr/sbin/mysqld \ 1328 local mysqld="${ROOT}/usr/sbin/mysqld \
1110 ${options} \ 1329 ${options} \
1111 --user=mysql \ 1330 --user=mysql \
1112 --skip-grant-tables \
1113 --basedir=${ROOT}/usr \ 1331 --basedir=${ROOT}/usr \
1114 --datadir=${ROOT}/${MY_DATADIR} \ 1332 --datadir=${ROOT}/${MY_DATADIR} \
1115 --skip-innodb \
1116 --skip-bdb \
1117 --skip-networking \
1118 --max_allowed_packet=8M \ 1333 --max_allowed_packet=8M \
1119 --net_buffer_length=16K \ 1334 --net_buffer_length=16K \
1335 --default-storage-engine=MyISAM \
1120 --socket=${socket} \ 1336 --socket=${socket} \
1121 --pid-file=${pidfile}" 1337 --pid-file=${pidfile}"
1338 #einfo "About to start mysqld: ${mysqld}"
1339 ebegin "Starting mysqld"
1122 ${mysqld} & 1340 ${mysqld} &
1341 rc=$?
1123 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1342 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
1124 maxtry=$((${maxtry}-1)) 1343 maxtry=$((${maxtry}-1))
1125 echo -n "." 1344 echo -n "."
1126 sleep 1 1345 sleep 1
1127 done 1346 done
1347 eend $rc
1128 1348
1349 if ! [[ -S "${socket}" ]]; then
1350 die "Completely failed to start up mysqld with: ${mysqld}"
1351 fi
1352
1353 ebegin "Setting root password"
1129 # Do this from memory, as we don't want clear text passwords in temp files 1354 # Do this from memory, as we don't want clear text passwords in temp files
1130 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1355 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
1131 "${ROOT}/usr/bin/mysql" \ 1356 "${ROOT}/usr/bin/mysql" \
1132 --socket=${socket} \ 1357 --socket=${socket} \
1133 -hlocalhost \ 1358 -hlocalhost \
1134 -e "${sql}" 1359 -e "${sql}"
1360 eend $?
1135 1361
1136 einfo "Loading \"zoneinfo\", this step may require a few seconds ..." 1362 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
1137
1138 "${ROOT}/usr/bin/mysql" \ 1363 "${ROOT}/usr/bin/mysql" \
1139 --socket=${socket} \ 1364 --socket=${socket} \
1140 -hlocalhost \ 1365 -hlocalhost \
1141 -uroot \ 1366 -uroot \
1142 -p"${pwd1}" \ 1367 -p"${MYSQL_ROOT_PASSWORD}" \
1143 mysql < "${sqltmp}" 1368 mysql < "${sqltmp}"
1369 rc=$?
1370 eend $?
1371 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
1144 1372
1145 # Stop the server and cleanup 1373 # Stop the server and cleanup
1374 einfo "Stopping the server ..."
1146 kill $(< "${pidfile}" ) 1375 kill $(< "${pidfile}" )
1147 rm -f "${sqltmp}" 1376 rm -f "${sqltmp}"
1148 einfo "Stopping the server ..."
1149 wait %1 1377 wait %1
1150 einfo "Done" 1378 einfo "Done"
1151} 1379}
1152 1380
1153# @FUNCTION: mysql_pkg_postrm 1381# @FUNCTION: mysql_pkg_postrm

Legend:
Removed from v.1.135  
changed lines
  Added in v.1.149

  ViewVC Help
Powered by ViewVC 1.1.20